org.apache.lucene.search

## Class Hits

- java.lang.Object
- - org.apache.lucene.search.Hits

- Deprecated.
  see `Searcher.search(Query, int)`, `Searcher.search(Query, Filter, int)` and `Searcher.search(Query, Filter, int, Sort)`:

         TopDocs topDocs = searcher.search(query, numHits);
         ScoreDoc[] hits = topDocs.scoreDocs;
         for (int i = 0; i < hits.length; i++) {
           int docId = hits[i].doc;
           Document d = searcher.doc(docId);
           // do something with current hit
           ...

      public final class Hits
      extends java.lang.Object

  A ranked list of documents, used to hold search results.

  Caution: Iterate only over the hits needed. Iterating over all hits is generally not desirable and may be the source of performance issues. If you need to iterate over many or all hits, consider using the search method that takes a `HitCollector`.

  Note: Deleting matching documents concurrently with traversing the hits, might, when deleting hits that were not yet retrieved, decrease `length()`. In such case, `ConcurrentModificationException` is thrown when accessing hit `n` ≥ current_`length()` (but `n` < `length()`_at_start).

- - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `Document` | `doc(int n)` Deprecated. Returns the stored fields of the nth document in this set.
    `int` | `id(int n)` Deprecated. Returns the id for the nth document in this set.
    `java.util.Iterator` | `iterator()` Deprecated. Returns a `HitIterator` to navigate the Hits.
    `int` | `length()` Deprecated. Returns the total number of hits available in this set.
    `float` | `score(int n)` Deprecated. Returns the score for the nth document in this set.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### length

          public final int length()

      Deprecated.
      Returns the total number of hits available in this set.

    - #### doc

          public final Document doc(int n)
                             throws CorruptIndexException,
                                    java.io.IOException

      Deprecated.
      Returns the stored fields of the nth document in this set.

      Documents are cached, so that repeated requests for the same element may return the same Document object.

      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error

    - #### score

          public final float score(int n)
                            throws java.io.IOException

      Deprecated.
      Returns the score for the nth document in this set.
      Throws:
        `java.io.IOException`

    - #### id

          public final int id(int n)
                       throws java.io.IOException

      Deprecated.
      Returns the id for the nth document in this set. Note that ids may change when the index changes, so you cannot rely on the id to be stable.
      Throws:
        `java.io.IOException`

    - #### iterator

          public java.util.Iterator iterator()

      Deprecated.
      Returns a `HitIterator` to navigate the Hits. Each item returned from `Iterator.next()` is a `Hit`.

      Caution: Iterate only over the hits needed. Iterating over all hits is generally not desirable and may be the source of performance issues. If you need to iterate over many or all hits, consider using a search method that takes a `HitCollector`.

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.